package de.cliffbreak.varo.managers;

import java.time.Duration;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZoneId;
import java.time.temporal.ChronoUnit;

import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.World.Environment;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

import de.cliffbreak.varo.Varo;

public class GameTimeManager {

    private final Varo plugin;
    // private static final int firstPlayTimeMinutes = 50;
    private static final int firstPlayTimeLoginMinutes = 10;
    private static final int protectionPeriodMinutes = 2;
    private static final int firstPlayTimeMinutes = 2;
    // private static final int firstPlayTimeMinutes = 360;
    // private static final int protectionPeriodMinutes = 11;
    // private static final LocalTime firstPlayStart = LocalTime.of(19, 20, 00);
    private static final LocalTime firstPlayStart = LocalTime.now().plusMinutes(1);
    private static final int firstRoundPreStartMinutes = 1;
    // private static final int playTimeMinutes = 30;
    // private static final int playTimeLoginMinutes = 5;
    private static final int playTimeMinutes = 1;
    private static final int playTimeLoginMinutes = 1;
    // private static final LocalTime playStart = LocalTime.of(19, 30, 00);
    // private static final LocalTime playStart = LocalTime.now().plusMinutes(30);
    private static final LocalTime playStart = LocalTime.now().plusSeconds(10);
    // private static final LocalTime playStart = LocalTime.now();

    public GameTimeManager(final Varo plugin) {
        this.plugin = plugin;
        this.startPlayTimeTimer();
        this.startBorderTimer();
    }

    /**
     * @return current Day the Server is running
     */
    public int currentDay() {
        return 1;
        // TODO: uncomment
        // final Instant instant = Instant.ofEpochMilli(this.plugin.getConfig().getLong("Varo.Start"));
        // final LocalDateTime start = instant.atZone(ZoneId.systemDefault()).toLocalDateTime();
        // final LocalDateTime current = LocalDateTime.now();
        // return (int) Duration.between(start, current).toDays() + 1;
    }

    // TODO: Rewrite
    public boolean canLogin() {
        final LocalTime currentTime = LocalTime.now();
        if (this.currentDay() == 1) {
            if (!currentTime.isBefore(firstPlayStart.minusMinutes(firstPlayTimeLoginMinutes))
                    && !currentTime.isAfter(firstPlayStart.plusMinutes(firstPlayTimeMinutes))) {
                return true;
            } else {
                return false;
            }
        } else {
            if (!currentTime.isBefore(playStart.minusMinutes(playTimeLoginMinutes))
                    && !currentTime.isAfter(playStart.plusMinutes(playTimeMinutes))) {
                return true;
            } else {
                return false;
            }
        }
    }

    // TODO: Rewrite
    public boolean isLoginTimeOver() {
        final LocalTime currentTime = LocalTime.now();
        if (this.currentDay() == 1) {
            if (currentTime.isAfter(firstPlayStart)) {
                return true;
            } else {
                return false;
            }
        } else {
            if (currentTime.isAfter(playStart)) {
                return true;
            } else {
                return false;
            }
        }
    }

    // TODO: Rewrite
    public int getLoginTimeLeft() {
        final LocalTime currentTime = LocalTime.now();
        if (this.currentDay() != 1) {
            return (int) currentTime.until(playStart, ChronoUnit.SECONDS);
        } else {
            return (int) currentTime.until(firstPlayStart, ChronoUnit.SECONDS);
        }
    }

    // TODO: Rewrite
    public int getGameTimeLeft() {
        final LocalTime currentTime = LocalTime.now();
        if (this.currentDay() != 1) {
            return (int) currentTime.until(playStart.plusMinutes(playTimeMinutes), ChronoUnit.MINUTES);
        } else {
            return (int) currentTime.until(firstPlayStart.plusMinutes(firstPlayTimeMinutes), ChronoUnit.MINUTES);
        }
    }

    // TODO: Rewrite
    private boolean isPlayTimeOver() {
        final LocalTime currentTime = LocalTime.now();
        if (this.currentDay() == 1) {
            if (currentTime.isAfter(firstPlayStart.plusMinutes(firstPlayTimeMinutes))) {
                return true;
            } else {
                return false;
            }
        } else {
            if (currentTime.isAfter(playStart.plusMinutes(playTimeMinutes))) {
                return true;
            } else {
                return false;
            }
        }
    }

    // TODO: BREAKING handle times after 24:00
    public int getPlayTimeDeltaSeconds() {
        final LocalTime currentTime = LocalTime.now();
        final LocalTime start = this.currentDay() == 1 ? firstPlayStart : playStart;
        return (int) currentTime.until(start, ChronoUnit.SECONDS);
    }

    // TODO: Rewrite
    // private void startPlayTimeTimer() {
    // new BukkitRunnable() {
    // boolean broadcast1 = false;
    // boolean broadcast2 = false;

    // @Override
    // public void run() {
    // if (currentDay() == 1) {
    // for (final Player p : Bukkit.getOnlinePlayers()) {
    // if (getGameTimeLeft() < 50 && getGameTimeLeft() > 45) {
    // if (!p.getLocation().getWorld().getEnvironment().equals(Environment.THE_END)) {
    // p.setGameMode(GameMode.ADVENTURE);
    // }
    // }
    // if (getGameTimeLeft() == 45) {
    // if (!p.getLocation().getWorld().getEnvironment().equals(Environment.THE_END)) {
    // p.setGameMode(GameMode.SURVIVAL);
    // }
    // if (!broadcast1) {
    // Bukkit.broadcastMessage("§aEs geht Los!");
    // Bukkit.broadcastMessage("Genießt die 10 minütige Schutzzeit.");
    // }
    // broadcast1 = true;
    // }
    // if (getGameTimeLeft() == 35) {
    // if (!broadcast2) {
    // Bukkit.broadcastMessage("Die Schutzzeit ist nur vorbei.");
    // }
    // broadcast2 = true;
    // }
    // }
    // }
    // if (isPlayTimeOver()) {
    // for (final Player p : Bukkit.getOnlinePlayers()) {
    // p.kickPlayer(plugin.getLangUtils().get("Service.KickPlayTimeOver"));
    // }
    // this.cancel();
    // }
    // }
    // }.runTaskTimer(this.plugin, 20l, 20l);
    // }
    private void startPlayTimeTimer() {
        new BukkitRunnable() {
            @Override
            public void run() {
                int timeDelta = getPlayTimeDeltaSeconds();
                int loginTimeSeconds = currentDay() == 1 ? firstPlayTimeLoginMinutes * 60 : playTimeLoginMinutes * 60;
                int playTimeSeconds = currentDay() == 1 ? firstPlayTimeMinutes * 60 : playTimeMinutes * 60;
                // System.out.println(timeDelta);
                if (timeDelta <= loginTimeSeconds && timeDelta > 0) {
                    plugin.getGameManager().setLoginPhase();
                } else if (currentDay() == 1 && (timeDelta <= 0 && timeDelta > firstRoundPreStartMinutes * -60)) {
                    plugin.getGameManager().setPreStart();
                } else if (currentDay() == 1 && (timeDelta <= firstRoundPreStartMinutes * -60
                        && timeDelta > protectionPeriodMinutes * -60)) {
                    plugin.getGameManager().setProtectionPhase();
                } else if (currentDay() > 1 && (timeDelta <= 0 && timeDelta > playTimeSeconds * -1)) {
                    plugin.getGameManager().setIngame();
                } else if (currentDay() == 1
                        && (timeDelta <= protectionPeriodMinutes * -60 && timeDelta > playTimeSeconds * -1)) {
                    plugin.getGameManager().setIngame();
                } else if (timeDelta <= playTimeSeconds * -1) {
                    plugin.getGameManager().setGameTimeOver();
                }
            }
        }.runTaskTimer(this.plugin, 20l, 20l);
    }

    private void startBorderTimer() {
        new BukkitRunnable() {
            final Instant instant = Instant.ofEpochMilli(plugin.getConfig().getLong("Varo.Border.LastUpdate"));
            LocalDateTime lastUpdate = instant.atZone(ZoneId.systemDefault()).toLocalDateTime();

            @Override
            public void run() {
                final LocalDateTime now = LocalDateTime.now();
                if (lastUpdate.getDayOfYear() < now.getDayOfYear()) {
                    if (currentDay() <= 1) {
                        System.out.println("Day 1 or smaller");
                        return;
                    }
                    if (now.getHour() == playStart.minusMinutes(30).getHour()
                            && now.getMinute() == playStart.minusMinutes(30).getMinute()) {
                        System.out.println("Shrinking Border");
                        lastUpdate = plugin.getBorderManager().broadcastBorderShrink();
                    }
                }
                if (now.getHour() == playStart.getHour() && now.getMinute() == playStart.getMinute()) {
                    System.out.println("Shrinking Border");
                    plugin.getBorderManager().shrinkBorder(playTimeMinutes * 60);
                }
            }
        }.runTaskTimer(this.plugin, 0, 60 * 20);
    }
}